"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ContainerBuilder_types, _ContainerBuilder_singletones;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContainerBuilder = void 0;
const Container_1 = require("./Container");
const TypeConfig_1 = require("./TypeConfig");
class ContainerBuilder {
    constructor({ types = [], singletones = {} } = {}) {
        _ContainerBuilder_types.set(this, void 0);
        _ContainerBuilder_singletones.set(this, void 0);
        __classPrivateFieldSet(this, _ContainerBuilder_types, [...types], "f");
        __classPrivateFieldSet(this, _ContainerBuilder_singletones, singletones, "f");
    }
    /**
     * Register type or factory
     */
    register(Type, alias) {
        const t = new TypeConfig_1.TypeConfig(Type);
        if (alias)
            t.as(alias);
        __classPrivateFieldGet(this, _ContainerBuilder_types, "f").push(t);
        return t;
    }
    /**
     * Register instance
     * (which will be a singleton with an alias)
     */
    registerInstance(instance, alias) {
        const t = new TypeConfig_1.TypeConfig(() => instance)
            .asSingleInstance()
            .as(alias);
        __classPrivateFieldGet(this, _ContainerBuilder_types, "f").push(t);
        return t;
    }
    /**
     * Create container with the registered types
     */
    container() {
        const BuilderType = Object.getPrototypeOf(this).constructor;
        return new Container_1.Container({
            types: Object.freeze([...__classPrivateFieldGet(this, _ContainerBuilder_types, "f")]),
            singletones: __classPrivateFieldGet(this, _ContainerBuilder_singletones, "f"),
            builderFactory: ({ singletones }) => new BuilderType({
                types: __classPrivateFieldGet(this, _ContainerBuilder_types, "f").filter(t => t.aliases.length),
                singletones
            })
        });
    }
}
exports.ContainerBuilder = ContainerBuilder;
_ContainerBuilder_types = new WeakMap(), _ContainerBuilder_singletones = new WeakMap();
//# sourceMappingURL=ContainerBuilder.js.map